﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;
using System.IO;

namespace race
{
    public partial class Form1 : Form
    {
        private  int zongCount = 0;
        private int rank = 0;
        
        const int _runway = 0;
        const int _hao = 1;
        const int _name = 2;
        const int _bidcount = 3;
        const int _yongtime = 4;
        const int _rank = 5;
        const int _EPC =6;

        private DateTime stime = DateTime.Now;
        string EPCList = null;

        string logofile = Application.StartupPath + "\\TitleLogo.gif";
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            if (File.Exists(logofile))
            {
                TitleLogo.Image = new Bitmap(logofile);
            }

            date1.Text = DateTime.Now.ToShortDateString();
            startbtn.Image = imageList3.Images[0];
            startbtn.Text = Properties.Settings.Default.Setting39;
            label4.Text = Properties.Settings.Default.Setting2;
            listView1.Columns[0].Text = Properties.Settings.Default.Setting27;
            listView1.Columns[1].Text = Properties.Settings.Default.Setting25;
            listView1.Columns[2].Text = Properties.Settings.Default.Setting26;
            listView1.Columns[3].Text = Properties.Settings.Default.Setting46;
            listView1.Columns[4].Text = Properties.Settings.Default.Setting47;
            listView1.Columns[5].Text = Properties.Settings.Default.Setting48;
            listView1.Columns[6].Text = Properties.Settings.Default.Setting28;

            string tmp = database.GetFromini("system", "systemname");
            if (tmp != "") this.Text = tmp;
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            time.Text = DateTime.Now.Subtract(stime).ToString();
            time.Text = time.Text.Substring(0, time.Text.Length - 2);

            for (int i = 0; i < DL6950Class.EPC_List.Length; i++)
            {
                if (DL6950Class.EPC_List[i].scaned == false) continue;

                if (DL6950Class.EPC_List[i].doYet) //已跑完
                {
                    listView1.Items[i].SubItems[_yongtime].Text = DL6950Class.EPC_List[i].time.Subtract(stime).ToString();
                    listView1.Items[i].SubItems[_rank].Text = DL6950Class.EPC_List[i].rank.ToString();
                    listView1.Items[i].ForeColor = Color.Blue;
                    listView1.Items[i].SubItems[_bidcount].Text = Properties.Settings.Default.Setting37;
                }
                else
                {
                    listView1.Items[i].SubItems[_bidcount].Text = DL6950Class.EPC_List[i].bibcount.ToString() + "/" + zongCount.ToString();
                }
                listView1.Focus();
                listView1.SelectedItems.Clear();
                listView1.Items[i].Selected = true;
                listView1.Items[i].EnsureVisible();
                DL6950Class.EPC_List[i].scaned = false;
            }
            
            if (rank == listView1.Items.Count + 1) //结束
            {
                timer2.Enabled = false;
                this.Cursor = Cursors.WaitCursor;
               // savebtn_Click(null, null);
                //showdetial(textBox1.Tag.ToString() + "," + button2.Tag.ToString(), textBox1.Text);
                startbtn_Click(null, null);
                MessageBox.Show(Properties.Settings.Default.Setting43 + "    ", "", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Cursor = Cursors.Default;
                linkLabel4.LinkColor = Color.Green;
                return;
            }

            timer1.Start();
        }
        private void timer2_Tick(object sender, EventArgs e)
        {
            timer2.Stop();
            EPCList = DL6950Class.Inventory(DL6950Class.frmcomportindex2, DL6950Class.fComAdr2, DL6950Class.DevicesModel);
            if (EPCList != null) 
            {
                epctxt.Text = EPCList;
                string[] epctmp = EPCList.Trim().Split(' ');
                for (int j = 0; j < epctmp.Length; j++)
                {
                    for (int i = 0; i < DL6950Class.EPC_List.Length; i++)
                    {
                        if (DL6950Class.EPC_List[i].EPCNO != epctmp[j]) continue;

                        if (!DL6950Class.EPC_List[i].doYet && DL6950Class.EPC_List[i].scaned == false) //EPC_List[i].scaned==true //没处理
                        {

                            if (DL6950Class.EPC_List[i].time != stime && DateTime.Now <= DL6950Class.EPC_List[i].time.AddSeconds(10))
                            {
                                DL6950Class.EPC_List[i].time = DateTime.Now;
                                continue;
                            }
                            DL6950Class.EPC_List[i].time = DateTime.Now;
                            if (++DL6950Class.EPC_List[i].bibcount > zongCount)
                            {
                                DL6950Class.EPC_List[i].doYet = true;
                                DL6950Class.EPC_List[i].rank = rank;
                                rank++;
                            }
                            DL6950Class.EPC_List[i].scaned = true;
                        }
                    }
                }
            }
            timer2.Start();
        }
        private string strAdd(string value)
        {
            try
            {
                int length = value.Length;
                string  newvalue = (int.Parse(value) + 1).ToString ();
                if (length > newvalue.Length)
                {
                    newvalue = value.Substring(0, length - newvalue.Length) + newvalue;
                }
                return newvalue;
            }
            catch
            {
                return "";
            }
        }
        private void item_btn1_Click(object sender, EventArgs e)
        {
            Form3 frm = new Form3();
            frm.Text = item_btn1.Text;
            frm.Show(this);
        }
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            button2.Enabled = textBox1.Text.Trim() != "";
            label4.Text = date1.Text + textBox1.Text;
        }
        private void showdetial(string idandbibcount, string name)
        {
            this.Cursor = Cursors.WaitCursor;
            string[] str = idandbibcount.Split(',');
            textBox1.Tag = str[0];  //id
            button2.Tag = str[1];  //bidcount 圈数
            textBox1.Text = name;

            zongCount = int.Parse(str[1]);

            listView1.BeginUpdate();
            listView1.Items.Clear();
            string sql = "select a.*,b.bibcount from dengjiTable as a left join NameTable as b on a.sid=b.id  where a.sid="+ textBox1.Tag .ToString ()+" and [a.date]=#"+ date1.Text +"# order by a.rank,a.runway,a.NO";
            OdbcDataReader rs = database.Datareader(sql);
            if (rs != null)
            {
                ListViewItem items=null;
                while (rs.Read())
                {
                    string[] item = { rs["runway"].ToString(), rs["NO"].ToString(), rs["Name"].ToString(), "1/" + rs["bibcount"].ToString(), rs["yongtime"].ToString (), rs["rank"].ToString (), rs["EPC"].ToString() };
                    items=new ListViewItem (item);
                    items.ImageIndex = 0;
                    listView1.Items.Add(items);
                    listView1.Items[listView1.Items.Count -1].SubItems[0].Tag = rs["id"].ToString();
                }
                rs.Dispose();
            }
            listView1.EndUpdate();
            listView1.Refresh();
            openevents.LinkColor = button2.Enabled ? Color.Green : Color.Gray;
            button2.LinkColor=listView1.Items .Count >0?Color.Green :Color .Gray;
            //listView1 .HeaderStyle=listView1 .Items .Count >0?ColumnHeaderStyle .Clickable:ColumnHeaderStyle.None;
            //listView1.Visible = listView1.Items.Count > 0;
            this.Cursor = Cursors.Default;
        }

        private void menuStrip1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen pen = new Pen(Color.Gainsboro, 2);
            g.DrawLine(pen,0,e.ClipRectangle.Height ,e.ClipRectangle.Width ,e.ClipRectangle.Height);
        }

        private void item_btn5_Click(object sender, EventArgs e)
        {
            frmreaderconnect frm = new frmreaderconnect(this.Left.ToString() + "," + this.Top.ToString() + "," + this.Width + "," + this.Height.ToString());
            frm.Text = item_btn5.Text;
            frm.ShowDialog(this);
        }

        private void item_btn2_Click(object sender, EventArgs e)
        {
            Form5 frm = new Form5();
            frm.Text = item_btn2.Text;
            frm.ShowDialog(this);
        }
        private void timer3_Tick(object sender, EventArgs e)
        {
            timer3.Stop();
            if (panel1.Visible == false) return;
            if (radioButton1.Checked && radioButton1.Enabled)
            {

                EPCList = DL6950Class.Inventory(DL6950Class.frmcomportindex1, DL6950Class.fComAdr1, DL6950Class.DevicesModel);
                if (EPCList != null)
                {
                    epctxt.Text = EPCList;
                    if (EPCList.IndexOf(DL6950Class.startTag + " ") >= 0) //检测到起令标签
                    {
                        startRace();
                        return;
                    }
                }
            }
            else if (radioButton3.Checked && starttime .Enabled ==false)
            {
                if (DateTime.Now > starttime.Value)
                {
                    startRace();
                    return;
                }
            }

            timer3.Start();
        }
        private void startRace()
        {
            timer3.Enabled = false;

            stime = DateTime.Now;
            string stimetxt = stime.ToLongTimeString(); // new DateTime(stime).ToLongTimeString();
            Array.Resize(ref DL6950Class.EPC_List, listView1.Items.Count);
            for (int i = 0; i < listView1.Items.Count; i++)
            {
                DL6950Class.EPC_List[i].EPCNO = listView1.Items[i].SubItems[_EPC].Text;
                DL6950Class.EPC_List[i].time = stime;
                DL6950Class.EPC_List[i].bibcount = 1;
                DL6950Class.EPC_List[i].rank = 0;
                DL6950Class.EPC_List[i].doYet = false;
                DL6950Class.EPC_List[i].scaned = false;
            }
            rank = 1; //初始化名次;
            statustxt.Text = Properties.Settings.Default.Setting35;
            startbtn.Text = Properties.Settings.Default.Setting33;
            startbtn.Image = imageList3.Images[1];
            timer1.Enabled = true;
            timer2.Enabled = true;
            time.Visible = true;
            panel1.Visible = false;
        }
        private void timer4_Tick(object sender, EventArgs e)
        {
            statustxt.Visible = !statustxt.Visible;
        }
        private bool ExportTotxt(string filename)
        {
            if (File.Exists(filename))
            {
                File.Delete(filename);
            }
            StreamWriter file = new StreamWriter(filename, false, System.Text.Encoding.Unicode);
            try
            {
                string line = "\t"+date1.Text + textBox1.Text+"\r\n";
                file.WriteLine(line);
                line = listView1.Columns[0].Text;
                for (int col = 1; col < listView1.Columns.Count-1; col++)
                {
                    line +="\t"+ listView1.Columns[col].Text;
                }
                file.WriteLine(line+"\r\n");

                for (int row = 0; row < listView1.Items .Count; row++)
                {
                    line = listView1.Items[row].SubItems[0].Text;
                    for (int col =1; col < listView1.Columns.Count-1; col++)
                    {
                        line += "\t"+ listView1.Items[row].SubItems [col].Text;
                    }
                    file.WriteLine(line);
                }
                file.Close();
                MessageBox.Show(Properties.Settings.Default.Setting42 + "       ", "", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + "       ", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            return false;
        }
        private bool ExportToHTML(string filename)
        {
            if (File.Exists(filename))
            {
                File.Delete(filename);
            }
            StreamWriter file = new StreamWriter(filename, false, System.Text.Encoding.Unicode);
            try
            {
                string line = "<html>\r\n<head>\r\n";
                line += "<title>" + date1.Text + textBox1.Text + "</title><meta http-equiv='Content-Type' content='text/html; charset=utf-8'>\r\n";
                line += "<style type='text/css'>\r\n";
                line += "	.border{ border:solid 1px #CCC;  font-size:13px; font-family:Arial, Helvetica, sans-serif}\r\n";
                line += "</style>\r\n";
                line += "</head>\r\n";
                line += "<body  style='text-align:center; padding-top:30px;'>\r\n";
                line += "<p style='font-weight:bold; font-size:17px'>" + date1.Text + textBox1.Text + "</p>\r\n";
                line += "<table border=1 cellspacing=0 cellpadding=2 width=960 style='border-collapse:collapse; background:#FFF; margin:0 auto'>\r\n";
                file.WriteLine(line);


                line = "<tr height=30 style='background:#999; color:#FFF; font-weight:bold' >\r\n";
                file.WriteLine(line);

                string[] textalign = new string[listView1.Columns.Count];
                for (int col = 0; col < listView1.Columns.Count - 1; col++) //标题
                {
                    if (listView1.Columns[col].TextAlign == HorizontalAlignment.Left)
                    {
                        textalign[col] = "align='left'";
                    }
                    else if (listView1.Columns[col].TextAlign == HorizontalAlignment.Center)
                    {
                        textalign[col] = "align='center'";
                    }
                    else
                    {
                        textalign[col] = "align='right'";
                    }
                    line = "<td  class='border'"+ textalign[col]+">" + listView1.Columns[col].Text + "</td>\r\n";
                    file.WriteLine(line);
                }
                line = "</tr>\r\n";
                file.WriteLine(line);

                
                for (int row = 0; row < listView1.Items.Count; row++) //内容
                {
                    line = "<tr height=30 >\r\n";
                    file.WriteLine(line);
                    for (int col = 0; col < listView1.Columns.Count - 1; col++)
                    {
                        line = "<td  class='border' "+ textalign[col] +"'>" + listView1.Items[row].SubItems[col].Text + "</td>\r\n";
                        file.WriteLine(line);
                    }
                    line = "</tr>\r\n";
                    file.WriteLine(line);
                }
                line += "</table>\r\n</body>\r\n</html>";
                file.WriteLine(line);
                file.Close();
                MessageBox.Show(Properties.Settings.Default.Setting42 + "       ", "", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + "       ", "", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            return false;
        }
        private void savebtn_Click(object sender, EventArgs e) //保存
        {

        }
        private void saveit(string file)
        {
            cToolStripMenuItem.Enabled = false;
            this.Cursor = Cursors.WaitCursor;
            listView1.BeginUpdate();
            string str = null;
            string where = null;
            for (int i =0; i < listView1 .Items .Count; i++)
            {
                //if (listView1 .Items[i].SubItems[0].Tag==null) continue; //没有成绩出来的无需更新；
                if (listView1.Items[i].SubItems[0].Tag != null)
                {
                    where = " [id]=" + listView1.Items[i].SubItems[0].Tag.ToString();
                }
                else
                {
                    where = " [sid]=" + textBox1.Tag.ToString() + " and [date]=#" + date1.Text + "# and [NO]='" + listView1.Items[i].SubItems[_hao].Text + "'";
                }
                str = "update dengjiTable set [yongtime]='" + listView1.Items[i].SubItems[_yongtime].Text + "',[rank]='" + listView1.Items[i].SubItems[_rank].Text + "',[filename]='"+ @file +"' where "+ where;
                if (!database.ExecuteNonQuery(str)) break;
            }
            listView1.EndUpdate();
            listView1.Refresh();
            Thread.Sleep(100);
            this.Cursor = Cursors.Default;
            cToolStripMenuItem.Enabled = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 0) return;
            if (MessageBox.Show(Properties.Settings.Default.Setting17 + "  ", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
            this.Cursor = Cursors.WaitCursor;
            listView1.BeginUpdate();
            string str = null, where = null;
            foreach(ListViewItem item in listView1 .SelectedItems)
            {
                if (item.SubItems[0].Tag !=null)
                {
                    where = "where [id]=" + item.SubItems[0].Tag.ToString();
                }
                else
                {
                    where=" where [sid]=" + textBox1.Tag.ToString() + " and [date]=#"+date1 .Text +"# and [NO]='"+item.SubItems[_hao].Text +"'";
                }
                str = "delete from dengjiTable  " + where;
                if (database.ExecuteNonQuery(str))
                {
                    listView1.Items.Remove(item);
                }
                else
                {
                    break;
                }
            }
            listView1.EndUpdate();
            listView1.Refresh();
            this.Cursor = Cursors.Default;
        }

        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (listView1.SelectedItems.Count == 0) return;
            if (menuStrip1.Enabled == false) return;
            this.Cursor = Cursors.WaitCursor;
            try
            {
                listView1.BeginUpdate();
                ListViewItem item = listView1.SelectedItems[0];
                string id = "0";
                if (item.SubItems[0].Tag != null)
                {
                   id= item.SubItems[0].Tag.ToString();
                }
                else
                {
                    string str = "select top 1 id from dengjiTable  where [sid]=" + textBox1.Tag.ToString() + " and [date]=#" + date1.Text + "# and [NO]='" + item.SubItems[_hao].Text + "'";
                    OdbcDataReader rs = database.Datareader(str);
                    if (rs == null) return;
                    if (rs.Read())
                    {
                        id= rs["id"].ToString();
                    }
                    rs.Dispose();
                }
                Form2 frm = new Form2(this.Left.ToString() + "," + this.Top.ToString() + "," + this.Width + "," + this.Height.ToString());
                frm.Tag = " [id]<>" + id + " and [sid]=" + textBox1.Tag.ToString() + " and [date]=#" + date1.Text + "# ";
                frm.Text = Properties.Settings.Default.Setting9;
                frm.textBox1.Text = item.SubItems[_hao].Text;
                frm.runway.Text = item.SubItems[_runway].Text;
                frm.textBox2.Text = item.SubItems[_name].Text;
                frm.EPCtext.Text = item.SubItems[_EPC].Text;
                if (frm.ShowDialog(this) == DialogResult.OK)
                {
                    string[] items = { frm.runway.Text.Trim(), frm.textBox1.Text.Trim(), frm.textBox2.Text.Trim(), frm.EPCtext.Text.Trim() };
                    string sql = "update dengjiTable set [runway]='" + items[0] + "',[NO]='" + items[1] + "',[Name]='" + items[2] + "',[EPC]='" + items[3] + "' where [id]=" + id;
                    if (database.ExecuteNonQuery(sql))
                    {
                        listView1.Items[item.Index].SubItems[_runway].Text = items[0];
                        listView1.Items[item.Index].SubItems[_hao].Text = items[1];
                        listView1.Items[item.Index].SubItems[_name].Text = items[2];
                        listView1.Items[item.Index].SubItems[_EPC].Text = items[3];
                    }
                }
            }
            finally
            {
                listView1.EndUpdate();
                listView1.Refresh();
                this.Cursor = Cursors.Default;
            }
        }

        private void sdfsdfToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form3 frm = new Form3();
            frm.Text = item_btn1.Text;
            frm.Show(this);
        }
        private void listView1_DrawColumnHeader(object sender, DrawListViewColumnHeaderEventArgs e)
        {
            TextFormatFlags flags = TextFormatFlags.VerticalCenter;
            if (listView1.Columns[e.ColumnIndex].TextAlign == HorizontalAlignment.Center)
            {
                flags |= TextFormatFlags.HorizontalCenter;
            }
            else if (listView1.Columns[e.ColumnIndex].TextAlign == HorizontalAlignment.Right)
            {
                flags |= TextFormatFlags.Right;
            }
            Graphics g = e.Graphics;
            Brush brush=new SolidBrush(Color.White);
            g.FillRectangle(brush,e.Bounds);
//            Pen pen = new Pen(Color.Red, 3);
            //g.DrawLine(pen, e.Bounds.X, e.Bounds.Y + e.Bounds.Height, e.Bounds.Width * 5, e.Bounds.Y + e.Bounds.Height);
            e.DrawText(flags);
        }
        private void label4_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen pen = new Pen(Color.Silver, 4);
            g.DrawLine(pen, e.ClipRectangle.X, e.ClipRectangle.Bottom, e.ClipRectangle.Right,e.ClipRectangle .Bottom);

        }

        private void openevents_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (startbtn.Tag.ToString() == "1") return;
            openevents.LinkColor = Color.Maroon;
            frmselevents frm = new frmselevents(this.Left.ToString ()+","+this.Top.ToString() + "," +this.Width+","+ this.Height.ToString());
            frm.Text = openevents.Text;
            if (frm.ShowDialog(this) == DialogResult.OK)
            {
                showdetial(frm.treeView1.SelectedNode.Name, frm.treeView1.SelectedNode.Text);
            }
            openevents.LinkColor = textBox1.Text != "" ? Color.Green : Color.Gray;
        }
        private void startbtn_Click(object sender, EventArgs e)
        {
            if (startbtn.Tag.ToString() == "0")
            {
                linkLabel1_LinkClicked(null, null);
                if (DL6950Class.frmcomportindex2 == -1) return;
                openevents.LinkColor = Color.Maroon;
                if (textBox1.Text.Trim() == "")
                {
                    openevents_LinkClicked(null, null);
                    if(textBox1 .Text =="")  return;
                }
                openevents.LinkColor = Color.Green;
                button2.LinkColor = Color.Maroon;
                if (listView1.Items.Count == 0)
                {
                    button2_LinkClicked(null, null);
                    if (listView1.Items.Count == 0) return;
                }
                button2.LinkColor = Color.Green;

                showdetial(textBox1.Tag + "," + button2.Tag, textBox1.Text);
                time.Text = "00:00:00";
                time.Visible = false;
                timer1.Enabled = timer2.Enabled = false;
                statustxt.Text = "";
                //linkLabel1.Enabled= linkLabel2.Enabled = button2.Enabled = menuStrip1.Enabled = false;
                listView1.BeginUpdate();
                foreach(ListViewItem  item in listView1 .Items)
                {
                    item.SubItems[_yongtime].Text = "";
                    item.SubItems[_rank].Text = "";
                }
                listView1 .EndUpdate();
                listView1 .Refresh ();
                panel1.Visible = true;
                startbtn.Tag = "1";
                starttime.Value = DateTime.Now.AddMinutes(30);
                radioButton1.Enabled = DL6950Class.frmcomportindex1 != -1;
                radioButton2.Checked = true;
                timer3.Enabled = true;
                linkLabel4.LinkColor = Color.Maroon;
            }
            else
            {
                timer1.Enabled = timer2.Enabled = timer3.Enabled = false;
                startbtn.Text = Properties.Settings.Default.Setting39;
                statustxt.Text ="";
                startbtn.Tag = "0";
                //linkLabel1.Enabled = linkLabel2.Enabled = button2.Enabled = menuStrip1.Enabled = true;
                startbtn.Image = imageList3.Images[0];
                panel1.Visible = false;
                linkLabel4.LinkColor = rank > 1 ? Color.Green : Color.Maroon;
                linkLabel3.LinkColor = rank > 1 ? Color.Maroon : Color.Gray;
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (startbtn.Tag.ToString() == "1") return;
            linkLabel1.LinkColor = Color.Maroon;
            if (DL6950Class.connect_reader() == false)
            {
                item_btn5_Click(null, null);
            }
            linkLabel1.LinkColor = DL6950Class.frmcomportindex2 != -1 ? Color.Green : Color.Gray;
        }

        private void button2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (startbtn.Tag.ToString() == "1") return;
            
            button2.LinkColor = Color.Maroon;
            zongCount = int.Parse(button2.Tag.ToString());
            string hao = "", runway = "";
            Form2 frm = new Form2(this.Left.ToString() + "," + this.Top.ToString() + "," + this.Width + "," + this.Height.ToString());
            frm.Tag = " [date]=#" + date1.Text + "# and [sid]=" + textBox1.Tag.ToString();
        againadd:
            frm.textBox1.Text = hao;
            frm.runway.Text = runway;
            frm.Text = button2.Text;
            frm.textBox2.Text = "";
            frm.EPCtext.Text = "";
            if (frm.ShowDialog(this) == DialogResult.OK)
            {
                string[] item = { frm.runway.Text.Trim(), frm.textBox1.Text.Trim(), frm.textBox2.Text.Trim(), "1/" + zongCount.ToString(), " ", " ", frm.EPCtext.Text.Trim() };
                string sql = "insert into dengjiTable ([sid],[date],[runway],[NO],[Name],[EPC]) values ('" + textBox1.Tag.ToString() + "','" + date1.Text + "','" + item[0] + "','" + item[1] + "','" + item[2] + "','" + item[6] + "') ";
                if (database.ExecuteNonQuery(sql))
                {
                    ListViewItem str = new ListViewItem(item);
                    str.ImageIndex = 0;
                    listView1.Items.Add(str);
                    listView1.Items[listView1.Items.Count - 1].Selected = true;
                    hao = strAdd(frm.textBox1.Text);
                    runway = strAdd(frm.runway.Text);
                    //listView1.HeaderStyle = listView1.Items.Count > 0 ? ColumnHeaderStyle.Clickable : ColumnHeaderStyle.None;
                    //listView1.Visible = listView1.Items.Count > 0;
                    goto againadd;
                }
            }
            button2.LinkColor = listView1.Items.Count > 0 ? Color.Green : Color.Gray;
        }
        private void listView1_DrawSubItem(object sender, DrawListViewSubItemEventArgs e)
        {
            TextFormatFlags flags = TextFormatFlags.VerticalCenter;
            if (listView1.Columns[e.ColumnIndex].TextAlign == HorizontalAlignment.Center)
            {
                flags |= TextFormatFlags.HorizontalCenter;
            }
            else if (listView1.Columns[e.ColumnIndex].TextAlign == HorizontalAlignment.Right)
            {
                flags |= TextFormatFlags.Right;
            }
            e.DrawBackground();
            e.DrawText(flags);
            e.DrawFocusRectangle(e.Item.Bounds);
            e.SubItem.BackColor = e.Item.Selected ? Color.LightBlue : Color.White;
        }

        private void menuStrip2_Paint(object sender, PaintEventArgs e)
        {
              Graphics g = e.Graphics;
            Pen pen = new Pen(Color.Silver, 2);
            g.DrawLine(pen, e.ClipRectangle.X, e.ClipRectangle.Top, e.ClipRectangle.Right,e.ClipRectangle.Top);
        }

        private void editbtn_Click(object sender, EventArgs e)
        {
            listView1_MouseDoubleClick(null, null);
        }

        private void 视图ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listView1.View = View.Tile;
        }
        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            button1.Enabled = radioButton2.Checked;

        }
        private void button1_Click_1(object sender, EventArgs e)
        {
            startRace();
        }

        private void label1_Click(object sender, EventArgs e)
        {
            startbtn_Click(null, null);
        }

        private void label1_MouseEnter(object sender, EventArgs e)
        {
            label1.ForeColor = Color.Green;
        }

        private void label1_MouseLeave(object sender, EventArgs e)
        {
            label1.ForeColor = Color.Black;
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            starttime.Enabled = button3.Enabled = radioButton3.Checked;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            starttime.Enabled = false;
        }

        private void systemNameToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmsystemname frm = new frmsystemname(this.Left.ToString() + "," + this.Top.ToString() + "," + this.Width + "," + this.Height.ToString());
            frm.Text = systemNameToolStripMenuItem.Text;
            frm.textBox1.Text = this.Text;
            if (frm.ShowDialog(this) == DialogResult.OK)
            {
                database.SaveToini("system", "systemname",frm.textBox1 .Text);
                this.Text = frm.textBox1.Text;
            }
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            editbtn.Enabled = delbtn.Enabled = menuStrip1.Enabled;
        }
        private void startbtn_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen pen = new Pen(Color.Gainsboro, 2);
            g.DrawRectangle(pen, e.ClipRectangle);

        }

        private void linkLabel3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (startbtn.Tag.ToString() == "1") return;
            if (listView1.Items.Count == 0) return;
            SaveFileDialog filesave = new SaveFileDialog();
            filesave.Title = dToolStripMenuItem.Text;
            filesave.Filter = "HTML(*.html)|*.html|txt(*.txt)|*.txt";
            filesave.FileName = date1.Text + textBox1.Text;
            if (filesave.ShowDialog(this) == DialogResult.OK)
            {

                this.Cursor = Cursors.WaitCursor;
                listView1.BeginUpdate();
                string filename = filesave.FileName;
                string Extension = System.IO.Path.GetExtension(filename).ToLower();
                bool result = false;
                switch (Extension)
                {
                    case ".txt":
                        result = ExportTotxt(filename);
                        break;
                    case ".html":
                        result = ExportToHTML(filename);
                        break;
                }
                if (result)
                {
                    saveit(filename);
                }
                listView1.EndUpdate();
                listView1.Refresh();
                this.Cursor = Cursors.Default;
            }

        }

        private void logoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openfile = new OpenFileDialog();
            openfile.Title = "Image file ";
            openfile.Filter = "jpg(*.jpg)|*.jpg|gif(*.gif)|*.gif";
            if (openfile.ShowDialog(this) == DialogResult.OK)
            {
                if(File.Exists(logofile))
                {
                    TitleLogo.Image.Dispose();
                    File.Delete(logofile);
                }
                File.Copy(openfile.FileName, logofile);
                Bitmap image = new Bitmap(logofile);
                TitleLogo.Image=image;
            }
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmabout frm = new frmabout();
            frm.Text = aboutToolStripMenuItem.Text;
            frm.Show(this);
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
