﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;

namespace race
{
    public partial class Form2 : Form
    {
        int pHeight = 0, pleft = 0, ptop = 0, pWidth = 0, step = 20;
        double opacity = 0.02;
        public Form2(string locationandsize)
        {
            InitializeComponent();
            string[] str = locationandsize.ToString().Split(',');
            pleft = int.Parse(str[0]);
            ptop = int.Parse(str[1]);
            pWidth = int.Parse(str[2]);
            pHeight = int.Parse(str[3]);
        }

        private void EPCtext_Enter(object sender, EventArgs e)
        {
            if (EPCtext.Text.Trim() == "")
            {
                EPCtext.Text = Properties.Settings.Default.Setting41;
                EPCtext.ForeColor = Color.DarkGray;
                EPCtext.SelectAll();
            }
        }
        private void EPCtext_KeyDown(object sender, KeyEventArgs e)
        {
            if (EPCtext.ForeColor != Color.Black)
            {
                EPCtext.Text = "";
                EPCtext.ForeColor = Color.Black;
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Trim() == "")
            {
                textBox1.Focus();
                MessageBox.Show(Properties.Settings.Default.Setting15 + label1.Text + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                return;
            }
            else if (textBox2.Text.Trim() == "")
            {
                textBox2.Focus();
                MessageBox.Show(Properties.Settings.Default.Setting15 + label2.Text + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                return;
            }
            else if (EPCtext.Text.Trim() == "" || EPCtext.ForeColor != Color.Black)
            {
                EPCtext.Focus();
                MessageBox.Show(Properties.Settings.Default.Setting15 + label4.Text + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                return;
            }
            bool result = false;
            string str = "select id from  dengjiTable where" + this.Tag.ToString() + " and [NO]='" + textBox1.Text.Trim() + "'";
            OdbcDataReader rs = database.Datareader(str);
            if (rs == null) return;
            result = rs.Read();
            rs.Dispose();
            if (result )
            {
                MessageBox.Show(label1.Text +" "+ textBox1.Text.Trim() +" "+ Properties.Settings.Default.Setting40 + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                textBox1.Focus();
                textBox1.SelectAll();
                return;
            }
            if (runway.Text.Trim() != "")
            {
                str = "select id from  dengjiTable where" + this.Tag.ToString() + " and [runway]='" + runway.Text.Trim() + "'";
                rs = database.Datareader(str);
                if (rs == null) return;
                result = rs.Read();
                rs.Dispose();
                if (result)
                {
                    MessageBox.Show(label3.Text + " " + runway.Text.Trim() + " " + Properties.Settings.Default.Setting40 + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    runway.Focus();
                    runway.SelectAll();
                    return;
                }
            }
            str = "select id from  dengjiTable where" + this.Tag.ToString() + " and [EPC]='" + EPCtext.Text.Trim() + "'";
            rs = database.Datareader(str);
            if (rs == null) return;
            result = rs.Read();
            rs.Dispose();
            if (result)
            {
                MessageBox.Show(label4.Text +" "+ EPCtext.Text.Trim() +" "+ Properties.Settings.Default.Setting40 + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                EPCtext.Focus();
                EPCtext.SelectAll();
                return;
            }
            this.DialogResult = DialogResult.OK;
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789\b".IndexOf(e.KeyChar) < 0;
        }

        private void EPCtext_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789abcdefgABCDEFG\b".IndexOf(e.KeyChar) < 0;
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            this.Location = new Point(pleft + (pWidth - this.Width) / 2, ptop);
            timer1.Enabled = true;
        }

        private void Form2_Shown(object sender, EventArgs e)
        {
            if (textBox1.Text != "") textBox2.Focus();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (DL6950Class.connect_reader() == false) return;
                button3.Enabled = false;
                for (int i = 0; i < 20; i++)
                {
                    string EPCList = DL6950Class.Inventory(DL6950Class.frmcomportindex2, DL6950Class.fComAdr2, DL6950Class.DevicesModel);
                    if (EPCList != null)
                    {
                        string[] epc = EPCList.Split(' ');
                        EPCtext.Text = epc[0];
                        EPCtext.ForeColor = Color.Black;
                        return;
                    }
                }
                MessageBox.Show(Properties.Settings.Default.Setting51 + "        ", "", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            finally
            {
                button3.Enabled = true;

                this.Cursor = Cursors.Default;
            }
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            this.Top += (pHeight - this.Size.Height) / step;
            if ((this.Top - ptop) > (pHeight - this.Size.Height) / 2)
            {
                this.Opacity = 1;
                timer1.Enabled = false;
                return;
            }
            if (this.Opacity < 1) this.Opacity += opacity;
            timer1.Start();
        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }
        }
    }
}
